package tp2cui;

BEGIN {
	use Exporter ();
	our ($VERSION, @ISA, @EXPORT, %EXPORT_TAGS, @EXPORT_OK);
	$VERSION=0.1;
	@ISA    = qw(Exporter);

	@EXPORT_OK = qw(
		&make_main_win
		&choose_ns_dialog
		&choose_repos_dialog
		&choose_filteropts_dialog
		&eventloop
		&leave_curses
		&return_curses
		&show_error
		&please_wait_msg
		&remove_please_wait_msg
		&populate_pkglist_widget
		&populate_installed_pkglist_widget
		&hide_pkglist_widget
		&hide_installed_pkglist_widget
		&restore_pkglist_widget
		&restore_installed_pkglist_widget
		&checkbox_dialog
		&create_loglist
		&create_textlog_window
		&create_pkglist_widget
		&create_installed_pkglist_widget
		&wait_button_textlog_window
		&addtext_to_textlog_window
		&set_progbar
	);
};

use tp2utils qw(
	get_ns_list
	);
use Curses;
use Curses::UI;
use Curses::UI::Common;
use Data::Dumper;
use Carp qw(cluck);

my $cui=undef;
my %LB_values=();

sub menu_loose_focus {
my $win=$_[0];
my $menu=$_[1];

	return;
	my $m=$win->getobj($menu);
	$m->loose_focus;
}

sub make_main_win($$$) {
my $title=$_[0];
my $id=$_[1];
my $menus=$_[2];

	# Return a UI::Window for putting things into...
	if(!defined($cui)) {
		$cui = new Curses::UI (
			-clear_on_exit	=> 1,
			-debug		=> 0,
		);
		$cui->set_binding(sub {exit;},"\cQ");
	}
	$cui->add(
		"menu","Menubar",-menu => $menus);
	$cui->add(
		"win_main",'Window',
		-border       	=> 1,
		-titlereverse 	=> 0,
		-padtop       	=> 2,
		-padbottom    	=> 3,
		-ipad         	=> 1,
		-onfocus	=> sub { menu_loose_focus($cui,"menu");},
		-title		=> $title
	);
	$cui->add(
		"win_bbox","Window",
		-border		=> 1,
		-y		=> -1,
		-height		=> 3,
	);
	return $cui;
}

#########################################################################
# Given a window id and a title pop a dialog allowing the user to 	#
# choose the namespace to perform the action on...			#
#########################################################################

sub listbox_callback {
	my $listbox = shift;
	my @sel = $listbox->get;
	@sel = ('<none>') unless @sel;
	$LB_values{$_[0]}=$sel[0];
}

sub buttonbox_callback {
	my $this = shift;
	$LB_values{bbox}=$this->get;
}

sub choose_ns_dialog($$) {
my $cui=$_[0];
my $title=$_[1];

my $idw=$cui->getobj('win_main');
my $idw2=$cui->getobj('win_bbox');
my ($nslist,$errs,$warns)=get_ns_list;
my %L=(); my @LL=(); my $i=1;
for (@$nslist) {
	$L{$i}=sprintf("%-20s  %s",$_->{NAME},$_->{ROOT});
	push @LL,$i;
	$i++;
}

	$idw->set_binding( sub {$idw2->focus();}, CUI_TAB());
	$idw2->set_binding( sub {$idw->focus();}, CUI_TAB());
	
	my $listbox => $idw->add(
		"choose_ns_list","Listbox",
		-y		=> 3,
		-x		=> 5,
		# -width		=> 75,
		# -height		=> 10,
		-values 	=> [@LL],
		-title		=> $title,
		-radio		=> 1,
		-border		=> 1,
		-labels		=> \%L,
		-vscrollbar	=> 1,
		-onchange	=> sub {listbox_callback($_[0],"choose_ns_list");},
	);

	#################################################################
	# Also add some buttons to the bottom window...			#
	#################################################################
	
	my $buts=$idw2->add(
		"choose_ns_buts","Buttonbox",
		-focusable	=> 1,
		-buttons => [
			{
				-label	=> " < Ok > ",
				-value	=> "OK",
				-shortcut => "o",
				-onpress  => sub {buttonbox_callback($_[0]);},
			},{
				-label	=> " < Cancel > ",
				-value	=> "CANCEL",
				-shortcut => "c",
				-onpress  => sub {buttonbox_callback($_[0]);},
			},{
				-label	=> " < Exit > ",
				-value	=> "EXIT",
				-shortcut => "x",
				-onpress  => sub {buttonbox_callback($_[0]);},
			}
		],
		-buttonalignment => "middle",
	);
	$buts->onFocus(sub {$buts->{-selected}=0;});

	$cui->draw;
	my $obj=$idw->getobj("choose_ns_list");
	$obj->focus(undef, 1);
	$cui->draw;
	delete $LB_values{bbox} if exists($LB_values{bbox});;
	while(1) {
		$cui->do_one_event;
		if(exists($LB_values{bbox})) {
			$idw2->delete("choose_ns_buts");
			$idw->delete("choose_ns_list");
			$cui->draw;
			last;
		}
	}
	$idw->clear_binding( sub {$idw2->focus();});
	$idw2->clear_binding( sub {$idw->focus();});
	$idw=$cui->getobj('menu');
	if(exists($LB_values{choose_ns_list}) && defined($LB_values{choose_ns_list})) {
		return($LB_values{bbox},$nslist->[$LB_values{choose_ns_list}-1]->{NAME});
	}
	return($LB_values{bbox},undef);
}

sub _fatal($$) {
my $cui=$_[0];
my $msg=$_[1];

	$cui->error($msg);
	exit(0);
}

{
my $orig_tp2path=$ENV{TP2PATH}||"";

sub choose_repos_dialog($$;$) {
my $cui=$_[0];
my $title=$_[1];
my $ns=$_[2];

	#################################################################
	# Check to see if the current namespace defines a REPOS line 	#
	# and use it if TP2 path is not set.				#
	#################################################################
	$ENV{TP2PATH}=$orig_tp2path;
	if(defined($ns)) {
		my ($nsobj,$err)=namespace_to_obj($ns);
		if(defined($nsobj)) {
			if(defined($nsobj->{REPOS})) {
				$ENV{TP2PATH}="$orig_tp2path $nsobj->{REPOS}";
			}
		}
	} 

	if(!exists($ENV{TP2PATH})) {
		_fatal($cui,"The 'TP2PATH' environment variable is not defined. Please set this to a list of repositories to choose from and retry the command.");
	}

	my $idw=$cui->getobj('win_main');
	my $idw2=$cui->getobj('win_bbox');
	my @repos_list=split(/[ ,]/,$ENV{TP2PATH});
	my @rp2=();
	for (@repos_list) {
		if(defined($_) && length($_)) {
			push @rp2,$_;
		}
	}
	@repos_list=@rp2;

	if(@repos_list==0) {
		_fatal($cui,"The 'TP2PATH' environment variable is not defined. Please set this to a list of repositories to choose from and retry the command.");
	}

	#################################################################
	# Clean the list - remove dups, leading spaces etc.		#
	#################################################################
	my $last="?";
	my @mlist=();
	for (@repos_list) {
		push @mlist,$_ if $_ ne $last;
		$last=$_;
	} 

	my %L=(); my @LL=(); my $i=1;
	for (@mlist) {
		if(substr($_,0,1) eq "/") {
			$L{$i}=sprintf("%-12s  %s","Directory",$_);
			push @LL,$i;
			$i++;
		} else {
			my ($x,$y)=split(/:/,$_);
			$x="Http://" if $x eq "HTTP" || $x eq "WWW";
			$x="Ftp://" if $x eq "FTP";
			$L{$i}=sprintf("%-12s  %s",$x,$y);
			push @LL,$i;
			$i++;
		}
	}

	$idw->set_binding( sub {$idw2->focus();}, CUI_TAB());
	$idw2->set_binding( sub {$idw->focus();}, CUI_TAB());
	
	my $listbox => $idw->add(
		"choose_repos_list","Listbox",
		-y		=> 3,
		-x		=> 5,
		# -width		=> 75,
		# -height		=> 10,
		-values 	=> [@LL],
		-title		=> $title,
		-radio		=> 1,
		-border		=> 1,
		-labels		=> \%L,
		-vscrollbar	=> 1,
		-onchange	=> sub {listbox_callback($_[0],"choose_repos_list");},
	);

	#################################################################
	# Also add some buttons to the bottom window...			#
	#################################################################
	
	my $buts=$idw2->add(
		"choose_repos_buts","Buttonbox",
		-focusable	=> 1,
		-buttons => [
			{
				-label	=> " < Ok > ",
				-value	=> "OK",
				-shortcut => "o",
				-onpress  => sub {buttonbox_callback($_[0]);},
			},{
				-label	=> " < Cancel > ",
				-value	=> "CANCEL",
				-shortcut => "c",
				-onpress  => sub {buttonbox_callback($_[0]);},
			},{
				-label	=> " < Exit > ",
				-value	=> "EXIT",
				-shortcut => "x",
				-onpress  => sub {buttonbox_callback($_[0]);},
			}
		],
		-buttonalignment => "middle",
	);
	$buts->onFocus(sub {$buts->{-selected}=0;});

	$cui->draw;
	delete $LB_values{bbox} if exists($LB_values{bbox});;
	delete $LB_values{choose_repos_list} if exists($LB_values{choose_repos_list});
	my $obj=$idw->getobj("choose_repos_list");
	$obj->focus(undef, 1);
	$cui->draw;
	while(1) {
		$cui->do_one_event;
		if(exists($LB_values{bbox})) {
			$idw2->delete("choose_repos_buts");
			$idw->delete("choose_repos_list");
			$cui->draw;
			last;
		}
	}
	$idw->clear_binding( sub {$idw2->focus();});
	$idw2->clear_binding( sub {$idw->focus();});
	$idw=$cui->getobj('menu');
	$idw->focus(undef, 1);
	if(exists($LB_values{choose_repos_list}) && defined($LB_values{choose_repos_list})) {

		return($LB_values{bbox},$mlist[$LB_values{choose_repos_list}-1]);
	}
	return($LB_values{bbox},undef);
}

sub checkbox_dialog($$$) {
my ($cui,$title,$hashr)=@_;
my $idw=$cui->getobj('win_main');
my $idw2=$cui->getobj('win_bbox');

	$idw->set_binding( sub {$idw2->focus();}, CUI_TAB());
	$idw2->set_binding( sub {$idw->focus();}, CUI_TAB());
	
	my $listbox => $idw->add(
		"checkbox_dialog","Listbox",
		-y		=> 1,
		-x		=> 2,
		# -width		=> 95,
		# -height		=> 15,
		-title		=> $title,
		-border		=> 1,
		-multi		=> 1,
		-vscrollbar	=> 1,
		-hscrollbar	=> 1,
		# -onchange	=> sub {listbox_callback($_[0],"checkbox_dialog");}
	);

	my $pkgw=$idw->getobj('checkbox_dialog');
	#################################################################
	# Also add some buttons to the bottom window...			#
	#################################################################
	
	my $buts=$idw2->add(
		"choose_ns_buts","Buttonbox",
		-focusable	=> 1,
		-buttons => [
			{
				-label	=> " < Ok > ",
				-value	=> "OK",
				-shortcut => "o",
				-onpress  => sub {buttonbox_callback($_[0]);},
			},{
				-label	=> " < Cancel > ",
				-value	=> "CANCEL",
				-shortcut => "c",
				-onpress  => sub {buttonbox_callback($_[0]);},
			},{
				-label	=> " < Exit > ",
				-value	=> "EXIT",
				-shortcut => "x",
				-onpress  => sub {buttonbox_callback($_[0]);},
			}
		],
		-buttonalignment => "middle",
	);
	$buts->onFocus(sub {$buts->{-selected}=0;});
	$pkgw->remove_entries;

	#################################################################
	# Build up the labels and values from the passed reference.	#
	#################################################################
	my @L=();
	my %h=();
	my @S=();
	for (sort(keys(%$hashr))) {
		push @L,$_;
		$h{$_}=$hashr->{$_}->{label};
		push @S,$_ if $hashr->{$_}->{value};
	}
	$pkgw->values(@L);
	$pkgw->labels(\%h);
	$pkgw->clear_selection();
	$pkgw->set_selection_noevents(@S);
	$cui->draw;
	$pkgw->focus;

	delete $LB_values{bbox} if exists($LB_values{bbox});;
	delete $LB_values{checkbox_dialog} if exists($LB_values{checkbox_dialog});
	my @options="";
	while(1) {
		$cui->do_one_event;
		if(exists($LB_values{bbox})) {
			@options=$pkgw->get;
			$idw2->delete("choose_ns_buts");
			$idw->delete("checkbox_dialog");
			$cui->draw;
			last;
		}
	}
	$idw->clear_binding( sub {$idw2->focus();});
	$idw2->clear_binding( sub {$idw->focus();});
	return($LB_values{bbox},[@options]);
}


sub create_installed_pkglist_widget($$$) {
my $cui=$_[0];
my $callback=$_[1];
my $namespace=$_[2];
my $idw=$cui->getobj('win_main');
my $idw2=$cui->getobj('menu');

	$idw->set_binding( sub {$idw2->focus();}, CUI_TAB());
	$idw2->set_binding( sub {$idw->focus();}, CUI_TAB());
	
	my $listbox => $idw->add(
		"installed_pkglist_widget","Listbox",
		-y		=> 1,
		-x		=> 2,
		# -width		=> 95,
		# -height		=> 15,
		-title		=> "Installed Packages [$namespace]",
		-border		=> 1,
		-onblur		=> sub {$idw2->focus();},
		-multi		=> 1,
		-vscrollbar	=> 1,
		-hscrollbar	=> 1,
		-onchange	=> sub {listbox_callback($_[0],"installed_pkglist_widget"); &$callback;}
	);
	my $idw3=$idw->getobj('installed_pkglist_widget');
	$idw3->focus(undef, 1);
	$idw3->set_binding( sub {$idw2->focus();}, CUI_TAB());
	$cui->draw;
	delete $LB_values{installed_pkglist_widget} if exists($LB_values{installed_pkglist_widget});
	return "installed_pkglist_widget";
}

sub create_pkglist_widget($$) {
my $cui=$_[0];
my $callback=$_[1];
my $idw=$cui->getobj('win_main');
my $idw2=$cui->getobj('menu');
my @repos_list=sort(split(/,/,$ENV{TP2PATH}));

	if(@repos_list==0) {
		_fatal($cui,"The 'TP2PATH' environment variable is not defined. Please set this to a list of repositories to choose from and retry the command.");
	}

	$idw->set_binding( sub {$idw2->focus();}, CUI_TAB());
	$idw2->set_binding( sub {$idw->focus();}, CUI_TAB());
	
	if($idw->getobj('pkglist_widget')) {
		delete $LB_values{pkglist_widget} if exists($LB_values{pkglist_widget});
		return "pkglist_widget";
	}

	my $listbox => $idw->add(
		"pkglist_widget","Listbox",
		-y		=> 1,
		-x		=> 2,
		# -width		=> 95,
		# -height		=> 15,
		-title		=> "Available Packages",
		-border		=> 1,
		-onblur		=> sub {$idw2->focus();},
		-multi		=> 1,
		-vscrollbar	=> 1,
		-hscrollbar	=> 1,
		-onchange	=> sub {listbox_callback($_[0],"pkglist_widget"); &$callback;}
	);
	my $idw3=$idw->getobj('pkglist_widget');
	$idw3->focus(undef, 1);
	$idw3->set_binding( sub {$idw2->focus();}, CUI_TAB());
	$cui->draw;
	delete $LB_values{pkglist_widget} if exists($LB_values{pkglist_widget});
	return "pkglist_widget";
}

sub choose_filteropts_dialog($$$) {
my $cui=$_[0];
my $title=$_[1];
my $optref=$_[2];

my $idw=$cui->getobj('win_main');
my $idw2=$cui->getobj('win_bbox');
my @repos_list=sort(split(/,/,$ENV{TP2PATH}));

	$idw->add(
		"win_filteropts",'Window',
		-titlereverse	=> 0,
		-border       	=> 1,
		-y		=> 4,
		-height		=> 5,
		-width 		=> 60,
		-ipadleft	=> 1,
		-title		=> $title,
	);
	my $filter_win=$idw->getobj('win_filteropts');
	$filter_win->add(
		"ch_b1","Checkbox",
		-label		=> "Show updates to installed packages",
		-y		=> 0,
		-checked	=> exists($optref->{updates}) && $optref->{updates},
	);
	$filter_win->add(
		"ch_b2","Checkbox",
		-label		=> "Show new packages to install",
		-y		=> 1,
		-checked	=> exists($optref->{new}) && $optref->{new},
	);
	$filter_win->add(
		"ch_b3","Checkbox",
		-label		=> "Show older revisions of installed packages",
		-checked	=> exists($optref->{older}) && $optref->{older},
		-y		=> 2,
	);

	$idw->loose_focus();
	my $x1=$filter_win->getobj("ch_b1");
	my $x2=$filter_win->getobj("ch_b2");
	my $x3=$filter_win->getobj("ch_b3");
	$x1->set_binding( sub {$x2->focus();}, KEY_DOWN);
	$x2->set_binding( sub {$x3->focus();}, KEY_DOWN);
	$x3->set_binding( sub {$x1->focus();}, KEY_DOWN);
	$x1->set_binding( sub {$x3->focus();}, KEY_UP);
	$x2->set_binding( sub {$x1->focus();}, KEY_UP);
	$x3->set_binding( sub {$x2->focus();}, KEY_UP);
	$idw->set_binding( sub {$idw2->focus();}, CUI_TAB());
	$idw2->set_binding( sub {$idw->focus();}, CUI_TAB());
	#################################################################
	# Also add some buttons to the bottom window...			#
	#################################################################
	
	my $buts=$idw2->add(
		"choose_repos_buts","Buttonbox",
		-focusable	=> 1,
		-buttons => [
			{
				-label	=> " < Ok > ",
				-value	=> "OK",
				-shortcut => "o",
				-onpress  => sub {buttonbox_callback($_[0]);},
			},{
				-label	=> " < Cancel > ",
				-value	=> "CANCEL",
				-shortcut => "c",
				-onpress  => sub {buttonbox_callback($_[0]);},
			},{
				-label	=> " < Exit > ",
				-value	=> "EXIT",
				-shortcut => "x",
				-onpress  => sub {buttonbox_callback($_[0]);},
			}
		],
		-buttonalignment => "middle",
	);
	$buts->onFocus(sub {$buts->{-selected}=0;});

	$filter_win->focus(undef, 1);
	$cui->draw;
	delete $LB_values{bbox} if exists($LB_values{bbox});;
	delete $LB_values{choose_repos_list} if exists($LB_values{choose_repos_list});
	while(1) {
		$cui->do_one_event;
		if(exists($LB_values{bbox})) {
			$idw2->delete("choose_repos_buts");
			$idw->delete("win_filteropts");
			$cui->draw;
			last;
		}
	}
	$optref->{updates}=$x1->get;
	$optref->{new}=$x2->get;
	$optref->{older}=$x3->get;
	$idw=$cui->getobj('menu');
	$idw->focus(undef, 1);
	return $LB_values{bbox};
}

sub set_progbar($$) {
my $cui=$_[0];
my $idw=$cui->getobj('win_main');
my $prgbar=$idw->getobj("win_progbar");
my $cval=$_[1];

	return if !defined($prgbar);
	$prgbar->pos($cval);
	$cui->draw;
}

#########################################################################
# The window will also contain a button to view the logs of the 	#
# software installation.						#
#########################################################################

sub create_loglist($$$) {
my $cui=$_[0];
my $title=$_[1];
my $logref=$_[2];
my $idw=$cui->getobj('win_main');
my $idw2=$cui->getobj('win_bbox');

	$idw->set_binding( sub {$idw2->focus();}, CUI_TAB());
	$idw2->set_binding( sub {$idw->focus();}, CUI_TAB());
	
	my $listbox => $idw->add(
		"loglist_widget","Listbox",
		-y		=> 1,
		-x		=> 2,
		# -width		=> 95,
		# -height		=> 15,
		-title		=> $title,
		-border		=> 1,
		-onblur		=> sub {$idw2->focus();},
		-multi		=> 0,
		-vscrollbar	=> 1,
		-hscrollbar	=> 1,
		-onchange	=> sub {listbox_callback($_[0],"loglist_widget");}
	);
	my $wid=$idw->getobj("loglist_widget");
	my @values=();
	my %labels=();
	my $xx=0;

	#################################################################
	# Rather than showing the raw log names - query the logs and	#
	# use text such as:						#
	# Failed preview install of blah @ time				#
	#################################################################

	my @text=();
	{
		my ($clog,$fd,$cline,$preview,$result);
		for $clog (@$logref) {
			$preview=0;
			$result="Unknown";
			open($fd,$clog);
			$cline=<$fd>;
			if($cline =~ /--preview/) {
				$preview=1;
			}
			while(<$fd>) {
				$cline=$_;
			}
			close($fd);
			if($cline =~ /Result: SUCCESS/) {
				$result="Successful";
			} elsif($cline =~ /Result: FAIL/) {
				$result="Failed";
			}
			my $r=(stat($clog))[9];
			my @x=localtime($r);
			my $tt=sprintf("%02d:%02d:%02d",$x[2],$x[1],$x[0]);
			

			my @b=split(/\+/,$clog);
			if($b[0] =~ /\/install$/) {
				my $y="$result";
				$y.=" preview" if $preview==1;
				$y.=" installation of '$b[1]' @ $tt";
				push @text,$y;
			}
			if($b[0] =~ /\/remove$/) {
				my $y="$result";
				$y.=" preview" if $preview==1;
				$y.=" removal of '$b[1]' @ $tt";
				push @text,$y;
			}
		}
	}

	for (@text) {
		push @values,$xx;
		$labels{$xx}=$_;
		$xx++;
	}
	$wid->values(@values);
	$wid->labels(\%labels);
	$wid->focus;
	$wid->{-selected}=0;

	#################################################################
	# Also create the buttons - view / cancel at the bottom of the	#
	# window...							#
	#################################################################

	my $buts=$idw2->add(
		"choose_loglist_buts","Buttonbox",
		-focusable	=> 1,
		-buttons => [
			{
				-label	=> " < View > ",
				-value	=> "VIEW",
				-shortcut => "v",
				-onpress  => sub {buttonbox_callback($_[0]);},
			},{
				-label	=> " < Cancel > ",
				-value	=> "CANCEL",
				-shortcut => "c",
				-onpress  => sub {buttonbox_callback($_[0]);},
			}
		],
		-buttonalignment => "middle",
	);
	my $wid2=$idw2->getobj("choose_loglist_buts");
	$wid2->{-selected}=0;
	$wid2->onFocus(sub {$wid2->{-selected}=0; $cui->draw;});
	$wid->set_binding( sub {$wid2->focus();}, CUI_TAB());
	$wid2->set_binding( sub {$wid->focus();}, CUI_TAB());
	$cui->draw;
	delete $LB_values{bbox} if exists($LB_values{bbox});;
	delete $LB_values{loglist_widget} if exists($LB_values{loglist_widget});;
	while(1) {
		$cui->do_one_event;
		if(exists($LB_values{bbox})) {
			if($LB_values{bbox} eq "VIEW") {
				#########################################
				# Hide our windows and pop up the text	#
				# widget ...				#
				#########################################
				my $e=$wid->get;
				if(!defined($e)) {
					print STDERR "None selected as yet!\n";
					delete $LB_values{bbox};
					next;
				}

				$wid2->hide;
				$wid->hide;
				my @d=();
				open(FD,"<$logref->[$e]");
				@d=<FD>;
				close(FD);
				my $twid=create_textlog_window($cui,"Log Details : $text[$e]",0);
				addtext_to_textlog_window($twid,join("",@d));
				wait_button_textlog_window($cui);
				$wid2->show;
				$wid->show;
				$cui->draw;
				$wid->focus;
				delete $LB_values{bbox};
				next;
			}
			if($LB_values{bbox} eq "CANCEL") {
				$idw2->delete("choose_loglist_buts");
				$idw->delete("loglist_widget");
				$cui->draw;
				last;
			}
		}
	}
}

sub create_textlog_window($$;$) {
my $cui=$_[0];
my $title=$_[1];
my $show_progbar=$_[2] || 0;
my $idw=$cui->getobj('win_main');
my $idw2=$cui->getobj('win_bbox');

	if($show_progbar==1) {
		$idw->add(
			"win_textlog",'TextEditor',
			-titlereverse	=> 1,
			-border       	=> 1,
			-vscrollbar	=> 1,
			-hscrollbar	=> 1,
			-height		=> 12,
			-minwidth 	=> 70,
			-readonly	=> 1,
			-title		=> $title,
		);
	} else {
		$idw->add(
			"win_textlog",'TextEditor',
			-titlereverse	=> 1,
			-border       	=> 1,
			-vscrollbar	=> 1,
			-hscrollbar	=> 1,
			-height		=> 15,
			-minwidth 	=> 70,
			-readonly	=> 1,
			-title		=> $title,
		);
	}
	if($show_progbar) {
		$idw->add(
			"win_progbar",'Progressbar',
			-titlereverse	=> 1,
			-border       	=> 1,
			-max		=> 100,
			-y		=> -1,
			-title		=> "Current Task Progress"
		);
	}

	my $x1=$idw->getobj("win_textlog");
	$idw->set_binding( sub {$idw2->focus();}, CUI_TAB());
	$idw2->set_binding( sub {$idw->focus();}, CUI_TAB());

	#################################################################
	# Also add some buttons to the bottom window...			#
	#################################################################
	
	my $buts=$idw2->add(
		"choose_repos_buts","Buttonbox",
		-focusable	=> 1,
		-buttons => [
			{
				-label	=> " < Ok > ",
				-value	=> "OK",
				-shortcut => "o",
				-onpress  => sub {buttonbox_callback($_[0]);},
			},
			# {
				# -label	=> " < Logs > ",
				# -value	=> "LOGS",
				# -shortcut => "l",
				# -onpress  => sub {buttonbox_callback($_[0]);},
			# },
		],
		-buttonalignment => "middle",
	);
	$buts->onFocus(sub {$buts->{-selected}=0;});

	$x1->focus(undef, 1);
	$cui->draw;
	delete $LB_values{bbox} if exists($LB_values{bbox});;
	return $x1;
}

sub addtext_to_textlog_window($$) {
my ($x1,$txt)=@_;

	my $ctxt=$x1->text;
	if(length($ctxt)) {
		$x1->text("$ctxt\n$txt");
	} else {
		$x1->text("$txt");
	}
	$x1->cursor_to_end;
	$x1->draw;
}

sub wait_button_textlog_window($) {
my $cui=$_[0];
my $idw=$cui->getobj('win_main');
my $idw2=$cui->getobj('win_bbox');

	delete $LB_values{bbox} if exists($LB_values{bbox});;
	while(1) {
		$cui->do_one_event;
		if(exists($LB_values{bbox})) {
			# if($LB_values{bbox} eq "LOG") {
				# my $x=$idw->getobj("win_textlog");
				# $x->hide;
				# $x->show;
				# next;
			# }
			$idw2->delete("choose_repos_buts");
			$idw->delete("win_textlog");
			eval {$idw->delete("win_progbar"); };
			$cui->draw;
			last;
		}
	}
	
	$idw=$cui->getobj('menu');
	$idw->focus(undef, 1);
	return $LB_values{bbox};
}

sub hide_installed_pkglist_widget($$) {
my ($cui,$pkglist)=@_;

my $idw=$cui->getobj('win_main');
my $pkgw=$idw->getobj($pkglist);
	
	$pkgw->hide;
}

sub hide_pkglist_widget($$) {
my ($cui,$pkglist)=@_;

my $idw=$cui->getobj('win_main');
my $pkgw=$idw->getobj($pkglist);
	
	$pkgw->hide;
}

sub restore_installed_pkglist_widget($$) {
my ($cui,$pkglist)=@_;

my $idw=$cui->getobj('win_main');
my $idw2=$cui->getobj('menu');
my $pkgw=$idw->getobj($pkglist);
	
	$pkgw->show;
	$idw->set_binding( sub {$idw2->focus();}, CUI_TAB());
	$idw2->set_binding( sub {$idw->focus();}, CUI_TAB());
	$pkgw->focus;
}

sub restore_pkglist_widget($$) {
my ($cui,$pkglist)=@_;

my $idw=$cui->getobj('win_main');
my $idw2=$cui->getobj('menu');
my $pkgw=$idw->getobj($pkglist);
	
	$pkgw->show;
	$idw->set_binding( sub {$idw2->focus();}, CUI_TAB());
	$idw2->set_binding( sub {$idw->focus();}, CUI_TAB());
	$pkgw->focus;
}

sub populate_installed_pkglist_widget($$$) {
my ($cui,$pkglist,$UNFILTERED_REPOS)=@_;
my $idw=$cui->getobj('win_main');
my $pkgw=$idw->getobj($pkglist);

	#################################################################
	# Clear out any existing entries for the widget first...	#
	#################################################################

	die("No pkglist widget found!") if !defined($pkgw);

	$verwidth=0;
	$pkgwidth=0;
	my $x;
	for $x (@$UNFILTERED_REPOS) {
		if(length($x->{NAME})>$pkgwidth) {
			$pkgwidth=length($x->{NAME});
		}
		if(length($x->{PKGVER})>$verwidth) {
			$verwidth=length($x->{PKGVER});
		}
	}

	$pkgw->remove_entries;
	my @L=();
	my %h=();
	my $xx=0;
	for $x (@$UNFILTERED_REPOS) {
		push @L,$xx;
		$h{$xx}=sprintf("%-*s  %-*s  %s",$pkgwidth,$x->{NAME},
			$verwidth,$x->{PKGVER},$x->{DESCRIPTION});
		$xx++;
	}
	$pkgw->values(@L);
	$pkgw->labels(\%h);
}

sub populate_pkglist_widget($$$) {
my ($cui,$pkglist,$UNFILTERED_REPOS)=@_;
my $idw=$cui->getobj('win_main');
my $pkgw=$idw->getobj($pkglist);

	#################################################################
	# Clear out any existing entries for the widget first...	#
	#################################################################

	die("No pkglist widget found!") if !defined($pkgw);

	$verwidth=0;
	$pkgwidth=0;
	my $x;
	for $x (@$UNFILTERED_REPOS) {
		if(length($x->{pkgname})>$pkgwidth) {
			$pkgwidth=length($x->{pkgname});
		}
		if(length($x->{pkgvers})>$verwidth) {
			$verwidth=length($x->{pkgvers});
		}
	}

	$pkgw->remove_entries;
	my @L=();
	my %h=();
	my $xx=0;
	for $x (@$UNFILTERED_REPOS) {
		push @L,$xx;
		$h{$xx}=sprintf("%-*s  %-*s  %s",$pkgwidth,$x->{pkgname},
			$verwidth,$x->{pkgvers},$x->{pkgldesc});
		$xx++;
	}
	$pkgw->values(@L);
	$pkgw->labels(\%h);
}


sub eventloop {
	$cui->mainloop();
}

sub leave_curses {
	$cui->leave_curses();
}

sub return_curses {
	$cui->reset_curses();
}

sub please_wait_msg($$) {
my $interface=$_[0];
my $msg=$_[1];

	$interface->status($msg);
}

sub remove_please_wait_msg($) {
my $interface=$_[0];

	$interface->nostatus;
}

sub show_error($$) {
my $interface=$_[0];
my $msg=$_[1];

	$interface->error($msg);
}

1;

